require 'yaml'

module Trekyll
    class TrekyllConfigurator

        INIT_CONFIGURABLE_ATTRIBUTES = [
            :key,
            :token,
            :board,
            :pages,
            :posts,
            :widgets,
            :blocks,
            :navigation
        ]
        attr_accessor *INIT_CONFIGURABLE_ATTRIBUTES

        # constructor
        def initialize()
            config = ""

            if File.file?('_init.yml')
                config = YAML.load_file('_init.yml')
            else
                puts "OHhh there is no '_init.yml' file in your project !!! "
            end

            @key            = config['developer_public_key']
            @token          = config['member_token']
            @board          = config['board']
            @pages          = config['pages']
            @posts          = config['posts']
            @widgets        = config['widgets']
            @blocks         = config['blocks']
            @navigation     = config['navigation']
        end

    end
end